/***********************************************************************
 * IBM Confidential 
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2006
 *
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 ************************************************************************/

package com.ibm.cds;

import org.eclipse.osgi.baseadaptor.HookConfigurator;
import org.eclipse.osgi.baseadaptor.HookRegistry;

public class CDSHookConfigurator implements HookConfigurator {
	//////////////// HookConfigurator //////////////////
	static public boolean 	SUPPRESS_ERROR_REPORTING = "true".equals(System.getProperty("ibm.cds.suppresserrors"));
	public void addHooks(HookRegistry hookRegistry) {
		try {
			Class.forName("com.ibm.oti.shared.SharedClassHelperFactory");
		} catch (ClassNotFoundException e) {
			// not running on J9
			if (!SUPPRESS_ERROR_REPORTING) {
				System.err.println("The IBM Class Sharing Adaptor will not work in this configuration.");
				System.err.println("You are not running on J9.");
				System.err.println("Detected VM is "+System.getProperty("java.fullversion").replace('\n',' '));
			}
			return;
		}
		CDSHookImpls hooks = new CDSHookImpls();
		hookRegistry.addClassLoadingStatsHook(hooks);
		hookRegistry.addClassLoadingHook(hooks);
		hookRegistry.addBundleFileWrapperFactoryHook(hooks);
	}

}
